; BeOSII/theme.jl

(let*
  (
    (font (get-font "-adobe-helvetica-medium-r-normal-*-10-*-*-*-p-*-iso8859-1"))
    (font-colors (list "black"
                       "black"))
    
    (title-width
      (lambda (w)
        (let
          ((w-width (car (window-dimensions w))))
        (max 0 (+ 20 (min (- w-width 55) (text-width (window-name w) font)))))))
          
    (update-title-width
      (lambda (w)
        (if (eq (window-get w 'current-frame-style) 'BeOSII) 
          (rebuild-frame w))))
    
    (title-images (list (make-image "mid-title-inactive.png")
                        (make-image "mid-title-active.png")))
    (close-images (list (make-image "close-inactive.png") 
                        (make-image "close-active.png")))
    (minimize-images (list (make-image "minimize-inactive.png")
                           (make-image "minimize-active.png")))
    (maximize-images (list (make-image "maximize-inactive.png")
                           (make-image "maximize-active.png")))
    (bottom-image (make-image "bottom-bar.png"))
    (top-image (make-image "top-bar.png"))
    (top-left-image (make-image "top-left.png"))
    (top-right-image (make-image "top-right.png"))
    (bottom-left-image (make-image "bottom-left.png"))
    (bottom-right-image (make-image "bottom-right.png"))
    (left-image (make-image "left-bar.png"))
    (right-image (make-image "right-bar.png"))

    (frame `(
        ((class . title)
         (background . ,top-image)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 0))
        ((class . left-border)
         (background . ,left-image)
         (left-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0))
        ((class . top-left-corner)
         (background . ,top-left-image)
         (left-edge . -5)
         (top-edge . -5))
        ((class . top-right-corner)
         (background . ,top-right-image)
         (right-edge . -5)
         (top-edge . -5))
        ((class . right-border)
         (background . ,right-image)
         (right-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0))
        ((class . bottom-border)
         (background . ,bottom-image)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -5))
        ((class . bottom-left-corner)
         (background . ,bottom-left-image)
         (left-edge . -5)
         (bottom-edge . -5))
        ((class . bottom-right-corner)
         (background . ,bottom-right-image)
         (right-edge . -5)
         (bottom-edge . -5))
        ((class . title)
         (background . ,title-images)
         (foreground . ,font-colors)
         (font . ,font)
         (text . ,window-name)
         (top-edge . -20)
         (left-edge . 11)
         (width . ,(lambda (w) (title-width w)))
         (x-justify . center)
         (y-justify . center))
        ((class . close-button)
         (background . ,close-images)
         (left-edge . -5)
         (top-edge . -20))
        ((class . iconify-button)
         (background . ,minimize-images)
         (left-edge . ,(lambda (w) (+ (title-width w) 11)))
         (top-edge . -20))
        ((class . maximize-button)
         (background . ,maximize-images)
         (left-edge . ,(lambda (w) (+ (title-width w) 27)))
         (top-edge . -20))
      ))
    (transient-frame `(
        ((class . title)
         (background . ,top-image)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 0))
        ((class . left-border)
         (background . ,left-image)
         (left-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0))
        ((class . top-left-corner)
         (background . ,top-left-image)
         (left-edge . -5)
         (top-edge . -5))
        ((class . top-right-corner)
         (background . ,top-right-image)
         (right-edge . -5)
         (top-edge . -5))
        ((class . right-border)
         (background . ,right-image)
         (right-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0))
        ((class . bottom-border)
         (background . ,bottom-image)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -5))
        ((class . bottom-left-corner)
         (background . ,bottom-left-image)
         (left-edge . -5)
         (bottom-edge . -5))
        ((class . bottom-right-corner)
         (background . ,bottom-right-image)
         (right-edge . -5)
         (bottom-edge . -5))
      ))
    (shaded-frame `(
        ((class . title)
         (background . ,title-images)
         (foreground . ,font-colors)
         (font . ,font)
         (text . ,window-name)
         (top-edge . -20)
         (left-edge . 11)
         (width . ,(lambda (w) (title-width w)))
         (x-justify . center)
         (y-justify . center))
        ((class . close-button)
         (background . ,close-images)
         (left-edge . -5)
         (top-edge . -20))
        ((class . iconify-button)
         (background . ,minimize-images)
         (left-edge . ,(lambda (w) (+ (title-width w) 11)))
         (top-edge . -20))
        ((class . maximize-button)
         (background . ,maximize-images)
         (left-edge . ,(lambda (w) (+ (title-width w) 27)))
         (top-edge . -20))
      ))
    (shaped-frame `(
        ((class . title)
         (background . ,top-image)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 0))
        ((class . left-border)
         (background . ,left-image)
         (left-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0))
        ((class . top-left-corner)
         (background . ,top-left-image)
         (left-edge . -5)
         (top-edge . -5))
        ((class . top-right-corner)
         (background . ,top-right-image)
         (right-edge . -5)
         (top-edge . -5))
        ((class . right-border)
         (background . ,right-image)
         (right-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0))
        ((class . bottom-border)
         (background . ,bottom-image)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -5))
        ((class . bottom-left-corner)
         (background . ,bottom-left-image)
         (left-edge . -5)
         (bottom-edge . -5))
        ((class . bottom-right-corner)
         (background . ,bottom-right-image)
         (right-edge . -5)
         (bottom-edge . -5))
        ((class . title)
         (background . ,title-images)
         (foreground . ,font-colors)
         (font . ,font)
         (text . ,window-name)
         (top-edge . -20)
         (left-edge . 11)
         (width . ,(lambda (w) (title-width w)))
         (x-justify . center)
         (y-justify . center))
        ((class . close-button)
         (background . ,close-images)
         (left-edge . -5)
         (top-edge . -20))
        ((class . iconify-button)
         (background . ,minimize-images)
         (left-edge . ,(lambda (w) (+ (title-width w) 11)))
         (top-edge . -20))
        ((class . maximize-button)
         (background . ,maximize-images)
         (left-edge . ,(lambda (w) (+ (title-width w) 27)))
         (top-edge . -20))
      ))
    (shaped-transient-frame `(
        ((class . title)
         (background . ,top-image)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 0))
        ((class . left-border)
         (background . ,left-image)
         (left-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0))
        ((class . top-left-corner)
         (background . ,top-left-image)
         (left-edge . -5)
         (top-edge . -5))
        ((class . top-right-corner)
         (background . ,top-right-image)
         (right-edge . -5)
         (top-edge . -5))
        ((class . right-border)
         (background . ,right-image)
         (right-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0))
        ((class . bottom-border)
         (background . ,bottom-image)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -5))
        ((class . bottom-left-corner)
         (background . ,bottom-left-image)
         (left-edge . -5)
         (bottom-edge . -5))
        ((class . bottom-right-corner)
         (background . ,bottom-right-image)
         (right-edge . -5)
         (bottom-edge . -5))
      ))
   )

  (add-frame-style 'BeOSII
    (lambda (w type)
      (case type
        ((default) frame)
        ((transient) transient-frame)
        ((shaded) shaded-frame)
        ((shaped) shaped-frame)
        ((shaped-transient) shaped-transient-frame)
        ((unframed) nil-frame)
       )
    )
  )
            
  (call-after-property-changed 'WM_NAME update-title-width)
)
